<%@ taglib prefix="s" uri="/WEB-INF/struts-tags.tld"%>
<s:include value="mainTop.jsp">
    <s:param name="scripts"></s:param>
    <s:param name="styles"></s:param>
    <s:param name="login">true</s:param>
</s:include>
<style>
    html {display: none;}

    #userNameField .x-form-focus,
    #passwordField .x-form-focus,
    #loginBtn.x-focus {
        outline: #33a9e1 solid 2px !important;
    }

    #loginBtn .x-btn-inner {
        color: white;
        font-weight: bold;
    }

    #loginBtn {
        border-color: #043C77;
        border-radius: 0px;
        background-image: -webkit-gradient(linear, to bottom, to top, color-stop(0%, #0D71BB), color-stop(100%, #004D87));
        background-image: -webkit-linear-gradient(to bottom, #0D71BB, #004D87);
        background-image: -moz-linear-gradient(to bottom, #0D71BB, #004D87);
        background-image: -o-linear-gradient(to bottom, #0D71BB, #004D87);
        background-image: linear-gradient(to bottom, #0D71BB, #004D87);
    }
    #loginBtn.x-btn-default-small-over {
        background-image: -webkit-gradient(linear, to bottom, to top, color-stop(0%, #0D85DD), color-stop(100%, #004D88));
        background-image: -webkit-linear-gradient(to bottom, #0D85DD, #004D88);
        background-image: -moz-linear-gradient(to bottom, #0D85DD, #004D88);
        background-image: -o-linear-gradient(to bottom, #0D85DD, #004D88);
        background-image: linear-gradient(to bottom, #0D85DD, #004D88);
    }
    #loginBtn.x-btn-default-small-pressed {
        background-image: -webkit-gradient(linear, to bottom, to top, color-stop(0%, #035A9C), color-stop(100%, #086FBA));
        background-image: -webkit-linear-gradient(to bottom, #035A9C, #086FBA);
        background-image: -moz-linear-gradient(to bottom, #035A9C, #086FBA);
        background-image: -o-linear-gradient(to bottom, #035A9C, #086FBA);
        background-image: linear-gradient(to bottom, #035A9C, #086FBA);
    }
</style>
<script type="text/javascript">
    //Framebusting code
    // When page is loaded, the above body style hides all content on the page.
    // If the page is used inside an IFrame, it will either remain blank or it will attempt the frame to bust
    // This script will only show up the document's content if the login.JSP page is not running in an iFrame
    if (self.location == top.location) {
        document.documentElement.style.display = 'block';
    } else {
        top.location = self.location;
    }

    Ext.onReady(function() {

        Ext.state.Manager.setProvider(new Ext.state.CookieProvider());

        this.authStore = Ext.create('Ext.data.Store', {
            fields : ['id', 'name', 'description', 'type'],
             proxy: {
                 type: 'ajax',
                 url: 'login.action?mainAction=getAuthSources',
                 reader: {
                     type: 'json'
                 }
             },
             autoLoad: true
        });

        // Auth source selector
        this.authSrcField = Ext.create('Ext.form.ComboBox', {
            id: 'authSelector',
            store: this.authStore,
            queryMode: 'local',
            editable: false,
            displayField: 'name',
            valueField: 'id',
            renderTo: 'authField',
            value: '${localItem}',
            stateful: true,
            stateId: 'login-authSourceSelector',
            listeners: {
                beforestaterestore: function(cmp, state) {
                    // Since the "LOCAL" option doesn't have a value (it's null/undefined) we need
                    // to return if we find an empty value so that the combobox doesn't get confused
                    // and leave the field blank. Stopping the
                    if (!state.value) {
                        return false;
                    }
                },
                scope: this
            },
            listConfig: {
                tpl: Ext.create('Ext.XTemplate',
                    '<ul><tpl for=".">',
                    '<li role="option" class="x-boundlist-item" title="{[this.getToolTip(values)]}">{[this.getEncodedSource(values.name)]}</li>',
                     '</tpl>' +
                     '</ul>',
                        {
                            getToolTip: function (values) {
                                if(values.type) {

                                    var toolTipTemplate = '${bundle["authSourceType.toolTip.template"]}';

                                    switch(values.type)
                                    {
                                        case 'VC':
                                            return Ext.String.format(toolTipTemplate, values.name, '${bundle["authSourceType.VC"]}');
                                            break;

                                        case 'OPEN_LDAP':
                                            return Ext.String.format(toolTipTemplate, values.name, '${bundle["authSourceType.OPEN_LDAP"]}');
                                            break;

                                        case 'VC_GROUP':
                                            return Ext.String.format(toolTipTemplate, values.name, '${bundle["authSourceType.VC_GROUP"]}');
                                            break;

                                        case 'ACTIVE_DIRECTORY':
                                            return Ext.String.format(toolTipTemplate, values.name, '${bundle["authSourceType.ACTIVE_DIRECTORY"]}');
                                            break;

                                        case 'OTHER':
                                            return Ext.String.format(toolTipTemplate, values.name, '${bundle["authSourceType.OTHER"]}');
                                            break;

                                        case 'LOCAL':
                                            return Ext.String.format(toolTipTemplate, values.name, '${bundle["authSourceType.LOCAL"]}');
                                            break;

                                        default:
                                            return values.name;
                                    }

                                } else {
                                    return values.name;
                                }
                            },
                            getEncodedSource: function(name) {
                                // Encode the sourceName to avoid XSS attacks
                                return Ext.String.htmlEncode(name);
                            }
                        }
                  )
            }
        });

        var userNameField = new Ext.form.TextField({
            id: 'userName',
            renderTo: 'userNameField',
            width: 150
        });

        var login = function() {
            var userName = userNameField.getValue();
            var password = passwordField.getValue();
            var authSourceId = authSrcField.getValue();
            var authSourceName = authSrcField.rawValue;
            
            var authSourceType = "LOCAL";
            var source = this.authStore.getById(authSourceId);
            if(source && !Ext.isEmpty(source.data.type)){
               authSourceType = source.data.type;
            }

            Ext.get('msgContainer').setVisible(false);
            if (userName != '' && password != '') {
                var loginForm = Ext.get('loginForm');
                var loginMask = Ext.get('loginMask');
                var authenticating = Ext.get('authenticating');

                loginMask.setVisible(true);
                loginForm.setStyle('opacity', 0.25);
                authenticating.setVisible(true);

                Ext.Ajax.request({
                    url: 'login.action',
                    method: 'POST',
                    params: Ext.urlEncode({mainAction: 'login', userName: userName, password: password, authSourceId: authSourceId, authSourceName: authSourceName, authSourceType: authSourceType, timezone: (-new Date().getTimezoneOffset()), languageCode: 'us'}),
                    disableCaching: true,
                    timeout: 900000,
                    success: function(response, options) {
                        var responseText = response.responseText;
                        if (responseText == 'ok') {
                            window.location.reload();
                        } else {
                            loginMask.setVisible(false);
                            loginForm.setStyle('opacity', 1);
                            authenticating.setVisible(false);

                            var errorMsg = '${bundle["login.incorrectLogin"]}';
                            if (responseText.toLowerCase().indexOf("locked") >= 0) {
                                errorMsg = '${bundle["login.incorrectLogin"]}';
                            } else if(responseText.toLowerCase().indexOf("role") >= 0) {
                                //TODO display localized message from backend API response
                                errorMsg = '${bundle["login.noRolesErrorMessage"]}';
                            } else if(responseText.indexOf("Unable to connect to any locators") >= 0 || responseText.indexOf("rejected from java.util.concurrent.ThreadPoolExecutor") >= 0) {
                                errorMsg = '${bundle["login.unableToConnectPlatform"]}';
                            } else if(responseText.indexOf("controllerDown") >= 0) {
                                errorMsg = '${bundle["login.controllerDown"]}';
                            } else if(responseText.indexOf("notAllowedInteractiveLogin") >= 0) {
                                errorMsg = "";
                            }

                            Ext.get('msgContainer').setVisible(true);
                            document.getElementById('msg').innerHTML = errorMsg;
                        }
                    },
                    failure: function(response, options) {
                        loginMask.setVisible(false);
                        loginForm.setStyle('opacity', 1);
                        authenticating.setVisible(false);
                    }
                });
            }
            else {
                Ext.get('msgContainer').setVisible(true);
                document.getElementById('msg').innerHTML = '${bundle["login.enterUserNameAndPassword"]}';
            }
        };

        var passwordField = new Ext.form.TextField({
            id: 'password',
            renderTo: 'passwordField',
            inputType: 'password',
            width: 150,
            scope: this,
            enableKeyEvents: true,
            listeners: {
                keydown: function(field, e) {
                    var event = e.browserEvent;
                    if ((event.which && event.which == 13) || (event.keyCode && event.keyCode == 13)) {
                        login();
                    }
                }
            }
        });

        var helpLink = new Ext.Component({
            renderTo: 'helpLink',
            html: '${bundle["chrome.help"]}',
            style: {
                color: '#838689',
                fontWeight: 'bold',
                cursor: 'pointer',
                display: 'inline'
            },
            margin: '10',
            listeners: {
                click: {
                    element: 'el',
                    fn: function() {
                        window.open('${docCenterBaseUrl}/index.jsp', '_blank');
                    }
                }
            }
        });

        var loginBtn = new Ext.Button({
            id: 'loginBtn',
            renderTo: 'loginBtnCell',
            text: '${bundle["login.login"]}',
            scope: this,
            handler: login
        });

        userNameField.focus();

        <s:if test="${dataRetrieverInitialized != true}">
            Ext.get('loginMask').setVisible(true);
            Ext.get('loginForm').setStyle('opacity', 0.25);

            Ext.get('notInitializedContainer').setVisible(true);
            document.getElementById('notInitializedMsg').innerHTML = '${bundle["login.dataRetrieverNotInitialized"]}';

            authSrcField.disable();
            userNameField.disable();
            passwordField.disable();
            loginBtn.disable();

            setTimeout('window.location.reload(true);', 10000);
        </s:if>
        
        <s:if test="${controllerDown == true}">
            Ext.get('msgContainer').setVisible(true);
            document.getElementById('msg').innerHTML = '${bundle["login.controllerDown"]}';
        </s:if>
   });
</script>
</head>
<body>
    <!--vghetto-->
    <table border="0" style="width:100%;height:100%;" background="images/rolo.jpg">
        <tr style="height:399px;">
            <!--vghetto<td style="width:654px;background-image:url(images/login/l1.png);">&nbsp;</td>-->
            <!--vghetto<td style="background-image:url(images/login/l3.png);">&nbsp;</td>-->
        </tr>
        <tr>
            <!--vghetto<td id="loginSection" colspan="2" style="vertical-align:middle;padding-left:40px;background-image:url(images/login/l2.png);">-->
            <td id="loginSection" colspan="2" style="vertical-align:middle;padding-left:40px;">
                <table border="0">
                    <s:if test="${firstRun == true}">
                        <tr><td id="firstRunInfo" class="loginLabel" colspan="5" style="font-size: 14px;padding-bottom: 20px;">${bundle["login.firstRun"]}</td></tr>
                    </s:if>
                    <tr>
                        <td style="position: relative;">
                            <table id="loginForm" border="0">
                                <tr>
                                    <td class="loginLabel">${bundle["login.authsource:"]}&nbsp;</td>
                                    <td id="authField"></td>
                                </tr>
                                <tr>
                                    <td colspan="2">&nbsp;</td>
                                </tr>
                                <tr>
                                    <td class="loginLabel">${bundle["login.userName:"]}&nbsp;</td>
                                    <td id="userNameField"></td>
                                </tr>
                                <tr>
                                    <td colspan="2">&nbsp;</td>
                                </tr>
                                <tr>
                                    <td class="loginLabel">${bundle["login.password:"]}&nbsp;</td>
                                    <td id="passwordField"></td>
                                </tr>
                                <tr>
                                    <td colspan="2">&nbsp;</td>
                                </tr>
                                <tr>
                                <td id="loginBtnCell" colspan="2" align="right"></td>
                                </tr>
                            </table>
                            <div id="loginMask" style="display: none; position: absolute; top: 0px; left: 0px; right: 0px; bottom: 0px;"></div>
                        </td>
                        <td width="20px">&nbsp;</td>
                        <!--vghetto<td width="1px" style="background-image:url(images/login/l4.png);background-repeat:repeat-y;"></td>-->
                        <td width="20px">&nbsp;</td>
                        <!--vghetto<td style="vertical-align: top;color:#87ceff;font-size:12px;">-->
                        <td style="vertical-align: top;color:#ffffff;font-size:20px;">
			Punching Cloud's vRealize Operations Manager
                            <!--vghetto<img src="images/login/product-name.png" />-->
                            <div style="display: none; margin-top:14px;" id="msgContainer"><img src="images/login/error.png" style="vertical-align: top; padding-right: 4px;" /><span id="msg"></span></div>
                            <div style="display: none; margin-top:14px;" id="notInitializedContainer"><img src="themes/light/images/grid/loading.gif" style="vertical-align: top; padding-right: 4px;" /><span id="notInitializedMsg"></span></div>
                            <div id="authenticating" style="display: none; padding-top: 56px;"><div style="padding-left: 3px;">${bundle["login.authenticating"]}</div><img src="images/login/progressbar.gif" style="margin-top: 8px;"/></div>
                        </td>
                    </tr>
                </table>
            </td>
        </tr>
        <tr style="height:42px;">
            <td colspan="2" style="background-color:#090b0d;" id="helpLink"></td>
        </tr>
    </table>
    <!-- This comment is necessary for AJAX handlers (see commonJS.jsp). Don't modify or remove. -->
    <!-- Login_Page -->
</body>
</html>
